<template lang="pug">
  div#lc-navigation.animated.fadeInDown
    div.ui.container.desktop
      div.ui.menu.inverted
        router-link.item(tag="a" :to="activeNav.left[0].url")
          img(:src="logo")
        div.ui.left.item
          router-link(tag="a" :to="nav.url" exactActiveClass="active" class="item" v-for="nav in activeNav.left" :key="nav.name") {{ nav.name }}
        div.ui.right.item
          a.item(target="_blank" rel="noopener noreferrer"
                 v-for="nav in activeNav.right" :active="nav.active" :href="nav.url" :key="nav.name" )
            i(:class="nav.icon + ' icon'")
            |  {{ nav.name }}
            i.external.alternate.icon
          a.item.centered(v-if="subNav" v-on:click="toggleSubNav")
            i(:class="(subNavActive ? 'caret square down up' : 'caret square down') + ' icon'")

    div.ui.fluid.mobile
      div.ui.menu.inverted.mobile-menu
        router-link.item(tag="a" :to="activeNav.left[0].url")
          img(:src="logo")
        div.right.item
          a.item(v-if="subNav" v-on:click="toggleSubNav")
            i(:class="(subNavActive ? 'caret square down up' : 'caret square down') + ' icon'")
          a#burger.item(v-on:click="mobileActive = !mobileActive")
            i.align.justify.icon
      div#mobile-items(v-if="mobileActive" :class="mobileClasses")
        div.ui.menu.stackable.inverted(v-on:click="mobileActive = false")
          router-link.item(tag="a" :to="nav.url" exactActiveClass="active" v-for="nav in activeNav.left" :key="nav.name") {{nav.name}}
          a.item(target="_blank" rel="noopener noreferrer"
                 v-for="nav in activeNav.right" :active="nav.active" :href="nav.url" :key="nav.name")
            i(:class="nav.icon + ' icon'")
            |  {{ nav.name }}
            i.external.alternate.icon
</template>

<script lang="ts">
import { Vue, Component, Watch } from 'vue-property-decorator'
import Images from '@/data/images'
import RootNav, { Navigation, Nav, SubNav } from '@/data/nav'
import 'semantic-ui-css/components/container.min.css'
import 'semantic-ui-css/components/menu.min.css'
import 'semantic-ui-css/components/item.min.css'
import 'semantic-ui-css/components/icon.min.css'
import 'animate.css/source/fading_entrances/fadeInDown.css'
import 'animate.css/source/fading_exits/fadeOutUp.css'

function getSubNav (): SubNav | null {
  const subKey = document.URL.split('/')[3]
  return RootNav.subnavs[subKey] || null
}

@Component
export default class LCNavigation extends Vue {
  imgs = Images
  subNav: SubNav | null = getSubNav()
  subNavActive = Boolean(this.subNav)
  logo: string = this.subNav ? this.subNav.logo : Images.core.lcWhite
  activeNav: Nav | SubNav = this.subNav || RootNav
  mobileActive = false
  mobileClasses = null

  @Watch('$route.params.pathMatch')
  onPathChange (value: string) {
    const sub = RootNav.subnavs[value]

    if (sub) {
      const csub = this.subNav
      this.subNav = sub
      if (!csub) {
        this.logo = sub.logo
        this.subNavActive = true
        this.activeNav = this.subNav
      }
    } else {
      this.logo = Images.core.lcWhite
      this.subNav = null
      this.subNavActive = false
      this.activeNav = RootNav
    }
  }

  toggleSubNav () {
    this.subNavActive = !this.subNavActive
    if (!this.subNav) return

    if (this.subNavActive) {
      this.activeNav = this.subNav
      this.logo = this.subNav.logo
    } else {
      this.activeNav = RootNav
      this.logo = Images.core.lcWhite
    }
    this.mobileActive = true
  }
}
</script>

<style lang="stylus" scoped>
.mobile
  display: none

#lc-navigation
  z-index: 1
  & .desktop
    padding-top: 2rem

.ui.inverted.menu
  background: rgba(27, 28, 29, 1)
  & .item
    &::before
      background: unset

    item-border-width = 1px
    &.active
      border-bottom: item-border-width solid white
    &:not(.active)
      margin-bottom: item-border-width

@media only screen and (max-device-width : 720px)
  .ui.container.desktop
    display: none
  .mobile
    display: unset

#burger, .mobile .caret.square.icon
  color: #fff
  font-size: 18px

.ui.menu.mobile-menu
  margin: unset
  padding: 0
  margin: 0

#mobile-items .menu
  position: absolute
  width: 100vw

#mobile-items .menu, #mobile-items .menu .item
  border-radius: unset

.external.icon
  font-size: 8px
  padding-left: 1em

.ui.menu.inverted .item img
  height: 32px
  width: unset
</style>
